//
// TwitterFox sync settings window
//
// Copyright (c) 2009 Kazuho Okui / naan studio, Inc. ALL RIGHTS RESERVED.
//

const TwitterFoxSync = {
  onload: function() {

    var req = new XMLHttpRequest;
    req.open('GET', 'https://twitter.com/account/verify_credentials.json', true, window.username, window.password);
    var target = this;
    req.onload  = function() {target.onVerifyAccount(req);}
    req.onerror = function() {target.onErrorVerifyAccount(req);}
    req.send(null);
  },

  onVerifyAccount: function(req) {
    if (req.status != 200) {
      var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
      prompt.alert(window, "Echofon", "Failed to verify your twitter id and password.");
      return;
    }

    var JSON = Components.classes["@mozilla.org/dom/json;1"].createInstance(Components.interfaces.nsIJSON);
    var ret = JSON.decode(req.responseText);
    this.twitter_id = ret.id;

    this.browser = document.getElementById('browser');
    this.browser.addProgressListener(this, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
    var notifier = Components.classes['@naan.net/twitternotifier;1'].getService(Components.interfaces.nsITwitterFox);
    this.browser.setAttribute('src', notifier.getSyncHostURL() + "?twitter_id=" + this.twitter_id);
  },

  onunload: function() {
  },

  onStateChange: function(progress, request, flag, status) {
    var channel;
    try {
      channel = request.QueryInterface(Components.interfaces.nsIHttpChannel);
    }
    catch (e) {
      return;
    }

    if (channel == null) return;

    var notifier = Components.classes['@naan.net/twitternotifier;1'].getService(Components.interfaces.nsITwitterFox);

    if(flag & Components.interfaces.nsIWebProgressListener.STATE_STOP &&
       flag & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT) {
      if (notifier.isSyncHost(channel.URI.host)) {
        try {
          var key = channel.getResponseHeader('X-Echofon-Sess');
          if (this.twitter_id != channel.getResponseHeader('X-Twitter-Id')) {

            var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
            prompt.alert(window, "You authorized different twitter account. Please retry.");
            var notifier = Components.classes['@naan.net/twitternotifier;1'].getService(Components.interfaces.nsITwitterFox);
            this.browser.loadURI(notifier.getSyncHostURL() + "?twitter_id=" + this.twitter_id);
            key = null;
          }
        }
        catch (e) {}
        if (key) {
          //dump(channel.URI.spec + ' ' + flag + ' / Secret key = ' + key + "\n");
          notifier.setSyncKey(window.username, key);
          var strings = document.getElementById("twitternotifier-strings");
          window.syncButton.setAttribute("label", strings.getString("disableSync"));
          window.setTimeout("window.close()", 2000);
        }
      }
    }
  },

  onLocationChange: function(aProgress, aRequest, URI) {
    this.URI = URI;
  },

  onProgressChange: function(aWebProgress, aRequest, curSelf, maxSelf, curTot, maxTot) {},
  onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {},
  onSecurityChange: function(aWebProgress, aRequest, aState) {},

  QueryInterface: function (aIID) {
    if (aIID.equals(Components.interfaces.nsIWebProgressListener)   ||
        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
        aIID.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  }
};
